`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: matuura mituhiro
// 
// Create Date:    18:57:34 06/30/2007 
// Design Name: 
// Module Name:    dot 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module dot(clk, hs, vs, h10, h1, m10, m1, s10, s1, ms100, ms10, ms1, d_out);
    input clk;
    input hs;
    input vs;
    input[3:0] h10;
    input[3:0] h1;
    input[3:0] m10;
    input[3:0] m1;
    input[3:0] s10;
    input[3:0] s1;
    input[3:0] ms100;
    input[3:0] ms10;
    input[3:0] ms1;
    output[2:0] d_out;

    reg[9:0] h_count;
    reg[9:0] v_count;
    reg[2:0] d_out;
	reg[2:0] tmp;
	reg[2:0] rgb;

    always @(negedge clk) begin
	    if (hs == 0) begin
            h_count <= 0;
        end
        else begin
            h_count <= h_count + 1;
        end
        tmp <= 0;
        if (h_count >= 32) begin
            if (h_count < 640 + 32) begin
                if (v_count >= 16) begin
                    if (v_count < 480 + 16) begin
                        tmp <= rgb;
                    end
                end
            end
		end
        d_out <= tmp;
    end

    always @(negedge hs) begin
        if (vs == 0) begin
            v_count <= 0;
        end
		else begin
            v_count <= v_count + 1;
        end
    end

	//VGAW16ŊԈĕ\WƂ
	wire [5:0] x;
	wire [5:0] y;

	assign x = h_count[9:4] - 2;
	assign y = v_count[9:4] - 1;

	wire [8:0] wg;

	hex_disp U_hex_disp_h10(.clk(clk), .x (x), .y(y), .px( 2), .py(2), .hex(h10), .on(wg[0]));
	hex_disp U_hex_disp_h1(.clk(clk), .x (x), .y(y), .px( 8), .py(2), .hex(h1), .on(wg[1]));
	hex_disp U_hex_disp_m10(.clk(clk), .x (x), .y(y), .px(15), .py(2), .hex(m10), .on(wg[2]));
	hex_disp U_hex_disp_m1(.clk(clk), .x (x), .y(y), .px(21), .py(2), .hex(m1), .on(wg[3]));
	hex_disp U_hex_disp_s10(.clk(clk), .x (x), .y(y), .px(28), .py(2), .hex(s10), .on(wg[4]));
	hex_disp U_hex_disp_s1(.clk(clk), .x (x), .y(y), .px(34), .py(2), .hex(s1), .on(wg[5]));
	hex_disp U_hex_disp_ms100(.clk(clk), .x (x), .y(y), .px(22), .py(13), .hex(ms100), .on(wg[6]));
	hex_disp U_hex_disp_ms10(.clk(clk), .x (x), .y(y), .px(28), .py(13), .hex(ms10), .on(wg[7]));
	hex_disp U_hex_disp_ms1(.clk(clk), .x (x), .y(y), .px(34), .py(13), .hex(ms1), .on(wg[8]));

	reg [4:0] g;

	//IuWFNg`
	always @(negedge clk) begin
		g <= 0;

		if(x == 13 & y == 4) g[0] <= 1;
		if(x == 13 & y == 8) g[1] <= 1;
		if(x == 26 & y == 4) g[2] <= 1;
		if(x == 26 & y == 8) g[3] <= 1;
		if(x == 20 & y == 21) g[4] <= 1;

		if(g | wg)
			rgb <= 3'b010;	//IuWFNgɊYWȂ̂ŗ
		else
			rgb <= 3'b111;	//IuWFNgɊYȂWȂ̂Ŕ

	end

endmodule
