`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: matuura mituhiro
// 
// Create Date:    21:15:21 03/16/2009 
// Design Name: 
// Module Name:    count 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module count(clk, rst, sec_clr, min_inc, hour_inc, hour10, hour1, min10, min1, sec10, sec1, msec100, msec10, msec1);
    input clk;
    input rst;
    input sec_clr;
    input min_inc;
    input hour_inc;
    output [3:0] hour10;
    output [3:0] hour1;
    output [3:0] min10;
    output [3:0] min1;
    output [3:0] sec10;
    output [3:0] sec1;
    output [3:0] msec100;
    output [3:0] msec10;
    output [3:0] msec1;

	`define PUSH 1

	reg [3:0] hour10;
	reg [3:0] sec1;
	reg [3:0] min10;
	reg [3:0] min1;
	reg [3:0] sec10;
	reg [3:0] hour1;
	reg [3:0] msec100;
	reg [3:0] msec10;
	reg [3:0] msec1;

	reg [47:0] usec_ct;
	reg status;

	always @(posedge clk) begin
		if (rst == `PUSH) begin
			usec_ct <= 0;
			msec1 <= 0;
			msec10 <= 0;
			msec100 <= 0;
			sec1 <= 0;
			sec10 <= 0;
			min1 <= 0;
			min10 <= 0;
			hour1 <= 0;
			hour10 <= 0;
		end
		else if (usec_ct < 25000) begin
			if (sec_clr == `PUSH) begin
				usec_ct <= 0;
				msec1 <= 0;
				msec10 <= 0;
				msec100 <= 0;
				sec1 <= 0;
				sec10 <= 0;
			end
			else begin
				usec_ct <= usec_ct + 1;
			end
		end
		else begin
			usec_ct <= 0;
			msec1 <= msec1 + 1;
			if (msec1 == 9) begin
				msec1 <= 0;
				msec10 <= msec10 + 1;
				if (msec10 == 9) begin
					msec10 <= 0;
					msec100 <= msec100 + 1;
					if (msec100 == 9) begin
						msec100 <= 0;
						sec1 <= sec1 + 1;
						if (sec1 == 9) begin
							sec1 <= 0;
							sec10 <= sec10 + 1;
							if (sec10 == 5) begin
								sec10 <= 0;
								min1 <= min1 + 1;
								if (min1 == 9) begin
									min1 <= 0;
									min10 <= min10 + 1;
									if (min10 == 5) begin
										min10 <= 0;
										hour1 <= hour1 + 1;
										if (hour1 == 9) begin
											hour1 <= 0;
											hour10 <= hour10 + 1;
										end
										else if (hour10 == 2 & hour1 == 3) begin
											hour1 <= 0;
											hour10 <= 0;
										end
									end
								end
							end
						end
					end
					else begin
						case (status)
							0:begin
								if (min_inc == `PUSH) begin
									min1 <= min1 + 1;
									if (min1 == 9) begin
										min1 <= 0;
										min10 <= min10 + 1;
										if (min10 == 5) begin
											min10 <= 0;
										end
									end
									status <= 1;
								end
								else
								if (hour_inc == `PUSH) begin
									hour1 <= hour1 + 1;
									if (hour1 == 9) begin
										hour1 <= 0;
										hour10 <= hour10 + 1;
									end
									else if (hour10 == 2 & hour1 == 3) begin
										hour1 <= 0;
										hour10 <= 0;
									end
									status <= 1;
								end
							end
							1:begin
								if (min_inc != `PUSH & hour_inc != `PUSH) begin
									status <= 0;
								end
							end
						endcase
					end
				end
			end
		end

	end

endmodule
