`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: matuura mituhiro
// 
// Create Date:    18:57:34 06/30/2007 
// Design Name: 
// Module Name:    dot 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module dot(clk, hs, vs, sw_clr, sw_up, sw_down, d_out);
    input clk;
    input hs;
    input vs;
    input sw_clr;
    input sw_up;
    input sw_down;
    output[2:0] d_out;

	`define PUSH 0

    reg[9:0] h_count;
    reg[9:0] v_count;
    reg[2:0] d_out;
	reg[2:0] tmp;
	reg[2:0] rgb;

    always @(negedge clk) begin
	    if (hs == 0) begin
            h_count <= 0;
        end
        else begin
            h_count <= h_count + 1;
        end
        tmp <= 0;
        if (h_count >= 32) begin
            if (h_count < 640 + 32) begin
                if (v_count >= 16) begin
                    if (v_count < 480 + 16) begin
                        tmp <= rgb;
                    end
                end
            end
		end
        d_out <= tmp;
    end

    always @(negedge hs) begin
        if (vs == 0) begin
            v_count <= 0;
        end
		else begin
            v_count <= v_count + 1;
        end
    end

	//VGAW16ŊԈăQ[WƂ
	wire [7:0] x;
	wire [7:0] y;

	assign x = h_count[9:4] - 2;
	assign y = v_count[9:4] - 1;

	//IuWFNg̈ړʂ̒`
	`define RIGHT 1
	`define LEFT -1
	`define DOWN 1
	`define UP -1

	reg [1:0] rstat;
	reg [7:0] rs;
	reg [7:0] racket_top;		//Pbg[̍W
	reg [7:0] racket_bottom;	//Pbg[̍W

	`define RACKET_SIZE 4	//Pbg̒
	`define RACKET_SPEED 3	//Pbgړpxi𕪎j
	`define RACKET_INI 9		//Pbg̏ʒu

	//{^ĂԃPbgړXe[g}V
	//0:J~
	//1:ֈړ
	//2:J~
	//3:ֈړ
	always @(negedge vs) begin

		if (sw_clr == `PUSH) begin
			rs <= 0;
			//Zbg̓T[ũ|WV
			racket_top <= `RACKET_INI;
			racket_bottom <= `RACKET_INI + `RACKET_SIZE;
			rstat <= 0;
		end
		else if (rs < `RACKET_SPEED) begin
			rs <= rs + 1;
		end
		else begin
			rs <= 0;
			case (rstat)
				1:begin
					if (sw_up != `PUSH) begin
						rstat <= 2;
					end
					else if (racket_top > 1) begin
						//{^ĂԂ̓Pbgֈړ
						racket_top <= racket_top + `UP;
						racket_bottom <= racket_bottom + `UP;
					end
				end
				3:begin
					if (sw_down != `PUSH) begin
						rstat <= 0;
					end
					else if (racket_bottom < 28) begin
						//{^ĂԂ̓Pbgֈړ
						racket_top <= racket_top + `DOWN;
						racket_bottom <= racket_bottom + `DOWN;
					end
				end
				default:begin
					if (sw_up == `PUSH) begin
						rstat <= 1;
					end
					else
					if (sw_down == `PUSH) begin
						rstat <= 3;
					end
				end
			endcase
		end

	end

	reg [7:0] bs;
	reg [7:0] bx;	//{[XW
	reg [7:0] by;	//{[YW
	reg [7:0] bmx;	//݂̉̈ړ
	reg [7:0] bmy;	//݂̏c̈ړ

	`define BALL_SPEED 2	//{[ړpxi𕪎j

	reg [7:0] serve;
	reg [7:0] receive;
	reg [2:0] color;

	//{[𓮂
	always @(posedge vs) begin

		if (sw_clr == `PUSH) begin
			bs <= 0;
			//Zbg̓T[u
			bx <= 37;
			by <= racket_top;
			bmx <= `LEFT;
			bmy <= `UP;
			serve <= 1;
			receive <= 0;
			color <= 7;
		end
		else if (bs < `BALL_SPEED) begin
			bs <= bs + 1;
		end
		else begin
			bs <= 0;

			if (bx <= 1) begin
				//̕ǂɓ
				bx <= 2;
				by <= by + bmy;
				bmx <= `RIGHT;
			end
			else if (bx == 38 & by >= racket_top & by <= racket_bottom) begin
				//V[u
				if (receive != 8'h99) begin
					bx <= 37;
					by <= by + bmy;
					bmx <= `LEFT;
				end
				else begin
					bmx <= 0;
					bmy <= 0;
				end
				if (receive[3:0] == 9) begin
					if (receive[7:4] == 9)begin
						//receive <= 0;
					end
					else begin
						receive <= receive + 7;
					end
				end
				else begin
					receive <= receive + 1;
				end
			end
			else if (bx >= 39) begin
				//V[usT[u
				if (serve != 8'h99) begin
					bx <= 37;
					by <= racket_top;
					bmx <= `LEFT;
					bmy <= `UP;
				end
				else begin
					bmx <= 0;
					bmy <= 0;
				end
				if (serve[3:0] == 9) begin
					if (serve[7:4] == 9) begin
						//serve <= 0;
					end
					else begin
						serve <= serve + 7;
					end
				end
				else begin
					serve <= serve + 1;
				end

				if (color == 7) begin
					color <= 1;
				end
				else begin
					color <= color + 1;
				end
			end
			else if (by <= 1) begin
				//̕ǂɓ
				bx <= bx + bmx;
				by <= 2;
				bmy <= `DOWN;
			end
			else if (by >= 28) begin
				//̕ǂɓ
				bx <= bx + bmx;
				by <= 27;
				bmy <= `UP;
			end
			else begin
				//{[̓R[g̒Ȃ̂ňړp
				bx <= bx + bmx;
				by <= by + bmy;
			end
		end

	end

	wire [3:0] wg;

	//XRA\
	hex_disp U_hex_disp_1000(.clk(clk), .x (x), .y(y), .px( 6), .py(2), .hex(receive[7:4]), .on(wg[3]));
	hex_disp U_hex_disp_0100(.clk(clk), .x (x), .y(y), .px(11), .py(2), .hex(receive[3:0]), .on(wg[2]));
	hex_disp U_hex_disp_0010(.clk(clk), .x (x), .y(y), .px(21), .py(2), .hex(serve[7:4]), .on(wg[1]));
	hex_disp U_hex_disp_0001(.clk(clk), .x (x), .y(y), .px(26), .py(2), .hex(serve[3:0]), .on(wg[0]));

	reg [4:0] g;

	//IuWFNg`
	always @(posedge clk) begin
		g <= 0;

		if (x >=  0 & x <=  39) begin
			if(y == 0) g[0] <= 1;	//̕
			if(y == 29) g[1] <= 1;	//̕
		end

		if (y >= 0 & y <= 29) begin
			if(x ==  0) g[2] <= 1;	//̕
		end

		if (y >= racket_top & y <= racket_bottom) begin
			if(x ==  39) g[3] <= 1;	//Pbg
		end

		if (x == bx & y == by) begin
			g[4] <= 1;				//{[
		end

		if(g | wg)
			rgb <= color;	//IuWFNgɊYWȂ̂Ŕ
		else
			rgb <= 3'b000;	//IuWFNgɊYȂWȂ̂ō

	end

endmodule
