`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: matuura mituhiro
// 
// Create Date:    13:03:19 09/23/2008 
// Design Name: 
// Module Name:    adr_dec 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module adr_dec(clk, pico_a, pico_d_in, pico_ws, pico_rs, pico_d_out, bram_din, bram_dout, bram_adr, bram_we, uart_rx_d, uart_tx_d, uart_tx_req, uart_tx_busy, portA_in, portB_in, portC_in, portD_in, portE_in, portF_in, portA_out, portB_out, portC_out, portD_out, portE_out, portF_out);
    input clk;
    input [7:0] pico_a;
    input [7:0] pico_d_in;
    input pico_ws;
    input pico_rs;
    output [7:0] pico_d_out;
    input [7:0] bram_din;
    output [7:0] bram_dout;
    output [7:0] bram_adr;
    output bram_we;
    input [7:0] uart_rx_d;
    output [7:0] uart_tx_d;
    output uart_tx_req;
    input uart_tx_busy;
    input [7:0] portA_in;
    input [7:0] portB_in;
    input [7:0] portC_in;
    input [7:0] portD_in;
    input [7:0] portE_in;
    input [7:0] portF_in;
    output [7:0] portA_out;
    output [7:0] portB_out;
    output [7:0] portC_out;
    output [7:0] portD_out;
    output [7:0] portE_out;
    output [7:0] portF_out;

    reg [7:0] pico_d_out;
    reg [7:0] bram_dout;
    reg [7:0] bram_adr;
    reg bram_we;
    reg uart_tx_req;
    reg [7:0] uart_tx_d;
    reg [7:0] portA_out;
    reg [7:0] portB_out;
    reg [7:0] portC_out;
    reg [7:0] portD_out;
    reg [7:0] portE_out;
    reg [7:0] portF_out;

    always@(posedge clk) begin
        if(pico_ws == 1)begin
            case (pico_a)
                8'h00:bram_dout <= pico_d_in;
                8'h02:bram_adr <= pico_d_in;
                8'h04:bram_we <= pico_d_in[0];

                8'h81:uart_tx_d <= pico_d_in;
                8'h82:uart_tx_req <= pico_d_in[0];

                8'h8a:portA_out[7:0] <= pico_d_in;
                8'h8b:portB_out[7:0] <= pico_d_in;
                8'h8c:portC_out[7:0] <= pico_d_in;
                8'h8d:portD_out[7:0] <= pico_d_in;
                8'h8e:portE_out[7:0] <= pico_d_in;
                8'h8f:portF_out[7:0] <= pico_d_in;

            endcase
        end
        case (pico_a)
            8'h00:pico_d_out <= bram_din;
            8'h02:pico_d_out <= bram_adr;
            8'h04:pico_d_out[0] <= bram_we;

            8'h80:pico_d_out <= uart_rx_d;
            8'h81:pico_d_out <= uart_tx_d;
            8'h82:pico_d_out[0] <= uart_tx_req;
            8'h83:pico_d_out[0] <= uart_tx_busy;

            8'h8a:pico_d_out <= portA_out[7:0];
            8'h8b:pico_d_out <= portB_out[7:0];
            8'h8c:pico_d_out <= portC_out[7:0];
            8'h8d:pico_d_out <= portD_out[7:0];
            8'h8e:pico_d_out <= portE_out[7:0];
            8'h8f:pico_d_out <= portF_out[7:0];

            8'h9a:pico_d_out <= portA_in[7:0];
            8'h9b:pico_d_out <= portB_in[7:0];
            8'h9c:pico_d_out <= portC_in[7:0];
            8'h9d:pico_d_out <= portD_in[7:0];
            8'h9e:pico_d_out <= portE_in[7:0];
            8'h9f:pico_d_out <= portF_in[7:0];

        endcase
    end

endmodule
