`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: matuura mituhiro
// 
// Create Date:    19:47:17 04/16/2008 
// Design Name: 
// Module Name:    uart_tx 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module uart_tx(clk, req, data_in, data_out, busy);
    input clk;
    input req;
    input [7:0] data_in;
    output data_out;
    output busy;

	reg data_out;
	reg busy;
	reg[7:0] data_buf;
	reg[15:0] count;

	parameter [15:0] CLOCK = 25000000 / 9600;

	always@(negedge clk or posedge req) begin
		if(req == 1)begin
			data_out <= 1;
			busy <= 0;
			data_buf <= data_in;
			count <= 1;
		end
		else begin
			case(count)
				0:begin
					data_out <= 1;
					busy <= 0;
				end
				CLOCK * 1 - 1:begin
					data_out <= 0;
					busy <= 1;
					count <= count + 1;
				end
				CLOCK * 2 - 1:begin
					data_out <= data_buf[0];
					data_buf <= (data_buf >> 1);
					count <= count + 1;
				end
				CLOCK * 3 - 1:begin
					data_out <= data_buf[0];
					data_buf <= (data_buf >> 1);
					count <= count + 1;
				end
				CLOCK * 4 - 1:begin
					data_out <= data_buf[0];
					data_buf <= (data_buf >> 1);
					count <= count + 1;
				end
				CLOCK * 5 - 1:begin
					data_out <= data_buf[0];
					data_buf <= (data_buf >> 1);
					count <= count + 1;
				end
				CLOCK * 6 - 1:begin
					data_out <= data_buf[0];
					data_buf <= (data_buf >> 1);
					count <= count + 1;
				end
				CLOCK * 7 - 1:begin
					data_out <= data_buf[0];
					data_buf <= (data_buf >> 1);
					count <= count + 1;
				end
				CLOCK * 8 - 1:begin
					data_out <= data_buf[0];
					data_buf <= (data_buf >> 1);
					count <= count + 1;
				end
				CLOCK * 9 - 1:begin
					data_out <= data_buf[0];
					data_buf <= (data_buf >> 1);
					count <= count + 1;
				end
				CLOCK * 10 - 1:begin
					data_out <= 1;
					count <= 0;
				end
				default:begin
					count <= count + 1;
				end
			endcase
		end
	end

endmodule
